<?php
/**
  * AdminChronopost
  * @category AdminTab
  *
  * @author Oxileo SAS <contact@oxileomicro.fr>
  * @copyright Oxileo SAS
  * @license Tous droits réservés / Le droit d'auteur s'applique (All rights reserved / French copyright law applies)
  * @version 2.0
  */

error_reporting(E_ALL);


if(!isset($_POST['orderid']) and !isset($_POST['orders']) and !isset($_GET['orders'])  && !isset($_GET['orderid'])) die('<h1>Informations de commande non transmises</h1>');
include('../../config/config.inc.php');
include('classes/ShippingServiceWSService.php');
include_once 'classes/PointRelaisServiceWSService.php';

require_once('chronopost.php');
$multi=array();

if((!array_key_exists('shared_secret', $_POST) or $_POST['shared_secret']!=Configuration::get('CHRONOPOST_SECRET'))
    && (!array_key_exists('shared_secret', $_GET) or $_GET['shared_secret']!=Configuration::get('CHRONOPOST_SECRET')))
    die('Secret does not match.');


if(strlen(Configuration::get('CHRONOPOST_GENERAL_ACCOUNT'))<8)
    die('Erreur : veuillez configurer le module avant de procéder à l\'édition des étiquettes.');

$return=false;

if(array_key_exists('multi', $_POST) or array_key_exists('multi', $_GET))
{
	$multi=array_key_exists('multi', $_POST)?$_POST['multi']:$_GET['multi'];
    $multi=json_decode($multi, true);
} else $multi=array();

if(array_key_exists('orders', $_POST) or array_key_exists('orders', $_GET))
{
	$orders=array_key_exists('orders', $_POST)?$_POST['orders']:$_GET['orders'];
	$orders=explode(';', $orders);
} else {
    $orders=array(array_key_exists('orderid', $_POST)?$_POST['orderid']:$_GET['orderid']);
    if(array_key_exists('return', $_POST)) $return=true;
    if(array_key_exists('multiOne', $_POST)) $multi=array($orders[0]=>$_POST['multiOne']);
}


if(count($orders) == 0) die('<h1>Aucune commande sélectionnée</h1>');
require_once('classes/PDFMerger.php');
@$pdf = new PDFMerger;

foreach($orders as $orderid)
{
    if(array_key_exists($orderid, $multi))
        $nb=$multi[$orderid];
    else $nb=1;


	$totalnb=$nb;

    while($nb>0)
    {
	    $file=tempnam("temp", "CHR");
	    $fp=fopen($file, 'w');

        $lt=@createLT($orderid, $totalnb, $return);
        if($lt===null) { 
            // error, skip it
            $nb--;
            continue;
        }
	    fwrite($fp, $lt);
	    fclose($fp);
	    @$pdf->addPDF($file, 'all');
        $nb--;
    }
}

try {
    $pdf->merge('download', 'Chronopost-LT-'.date("Ymd-Hi").'.pdf');
} catch(Exception $e)
{
    echo "<p>Le fichier généré est invalide.</p>";
}


function createLT($orderid, $totalnb=1, $isReturn=false)
{
	$o=new Order($orderid);
	$a=new Address($o->id_address_delivery);
    $cust=new Customer($o->id_customer);

    // at least 2 skybills for orders >= 30kg
    $o=new Order($orderid);
    if($o->getTotalWeight()*Configuration::get('CHRONOPOST_GENERAL_WEIGHTCOEF')>=30 && $totalnb==1)
    {
        echo "<script>alert('Vous devez générer au moins 2 étiquettes pour les commandes de plus de 30kg');history.back();</script>";
        exit();
    }

    

	$recipient=new recipientValue();
	$recipient->recipientAdress1=substr($a->address1,0,35);
	$recipient->recipientAdress2=substr($a->address2,0,35);
	$recipient->recipientCity=substr($a->city,0,30);
	$recipient->recipientCivility='M';
	$recipient->recipientContactName=substr($a->firstname.' '.$a->lastname,0,35);
	$c=new Country($a->id_country);
	$recipient->recipientCountry=$c->iso_code;
	$recipient->recipientName=substr($a->company,0,35);
	$recipient->recipientName2=substr($a->firstname.' '.$a->lastname,0,35);
	$recipient->recipientZipCode=$a->postcode;
	$recipient->recipientPhone=$a->phone_mobile==null?$a->phone:$a->phone_mobile;
	$recipient->recipientMobilePhone=$a->phone_mobile;
    $recipient->recipientEmail=$cust->email;

    if($isReturn)
    {
      	$recipient->recipientAdress1=Configuration::get('CHRONOPOST_SHIPPER_ADDRESS');
	    $recipient->recipientAdress2=Configuration::get('CHRONOPOST_SHIPPER_ADDRESS2');
	    $recipient->recipientCity=Configuration::get('CHRONOPOST_SHIPPER_CITY');
	    $recipient->recipientCivility=Configuration::get('CHRONOPOST_SHIPPER_CIVILITY');
	    $recipient->recipientContactName=Configuration::get('CHRONOPOST_SHIPPER_CONTACTNAME');
	    $recipient->recipientCountry='FR';
	    $recipient->recipientName=Configuration::get('CHRONOPOST_SHIPPER_NAME');
	    $recipient->recipientName2=Configuration::get('CHRONOPOST_SHIPPER_NAME2');
	    $recipient->recipientZipCode=Configuration::get('CHRONOPOST_SHIPPER_ZIPCODE');
    }


	$esd=new esdValue();
	$esd->specificInstructions='aucune';
	//$esd->retrievalDateTime=date('Y-m-d\TH:i:s', $retrievalDateTime);
	//$esd->closingDateTime=>date('Y-m-d\TH:i:s', $closingDateTime);
	/*$esd->height=(float)$_POST['height'];
	$esd->width=(float)$_POST['width'];
	$esd->length=(float)$_POST['length'];*/

	$esd->height='';
	$esd->width='';
	$esd->length='';


	$header=new headerValue();
	$params=new shipping();
	$skybill=new skybillValue();
	$skybill->evtCode='DC';
	$skybill->objectType='MAR';
    $skybill->productCode='01'; // CHRONO 13

    if(array_key_exists('advalorem', $_POST) && $_POST['advalorem']=='yes')
        $skybill->insuredValue=(int)$_POST['advalorem_value'];

    $header->accountNumber=Configuration::get('CHRONOPOST_GENERAL_ACCOUNT');
    $header->subAccount=Configuration::get('CHRONOPOST_GENERAL_SUBACCOUNT');
    $params->password=Configuration::get('CHRONOPOST_GENERAL_PASSWORD');





	$header->idEmit='CHRFR';


	$shipper=new shipperValue(); 
	$shipper->shipperAdress1=Configuration::get('CHRONOPOST_SHIPPER_ADDRESS');
	$shipper->shipperAdress2=Configuration::get('CHRONOPOST_SHIPPER_ADDRESS2');
	$shipper->shipperCity=Configuration::get('CHRONOPOST_SHIPPER_CITY');
	$shipper->shipperCivility=Configuration::get('CHRONOPOST_SHIPPER_CIVILITY');
	$shipper->shipperContactName=Configuration::get('CHRONOPOST_SHIPPER_CONTACTNAME');
	$shipper->shipperCountry='FR';
	$shipper->shipperName=Configuration::get('CHRONOPOST_SHIPPER_NAME');
	$shipper->shipperName2=Configuration::get('CHRONOPOST_SHIPPER_NAME2');
	$shipper->shipperZipCode=Configuration::get('CHRONOPOST_SHIPPER_ZIPCODE');

    if($isReturn)
    {
        $shipper=new shipperValue(); 
	    $shipper->shipperAdress1=substr($a->address1,0,35);
	    $shipper->shipperAdress2=substr($a->address2,0,35);
	    $shipper->shipperCity=substr($a->city,0,30);
	    $shipper->shipperCivility='M';
	    $shipper->shipperContactName=substr($a->firstname.' '.$a->lastname,0,35);
	    $shipper->shipperCountry='FR';
	    $shipper->shipperName=substr($a->company,0,35);
	    $shipper->shipperName2=substr($a->firstname.' '.$a->lastname,0,35);
	    $shipper->shipperZipCode=$a->postcode;

    }


	$customer=new customerValue();
	$customer->customerAdress1=Configuration::get('CHRONOPOST_CUSTOMER_ADDRESS');
	$customer->customerAdress2=Configuration::get('CHRONOPOST_CUSTOMER_ADDRESS2');
	$customer->customerCity=Configuration::get('CHRONOPOST_CUSTOMER_CITY');
	$customer->customerCivility=Configuration::get('CHRONOPOST_CUSTOMER_CIVILITY');
	$customer->customerContactName=Configuration::get('CHRONOPOST_CUSTOMER_CONTACTNAME');
	$customer->customerCountry='FR';
	$customer->customerName=Configuration::get('CHRONOPOST_CUSTOMER_NAME');
	$customer->customerName2=Configuration::get('CHRONOPOST_CUSTOMER_NAME2');
	$customer->customerZipCode=Configuration::get('CHRONOPOST_CUSTOMER_ZIPCODE');


	$ref=new refValue();
    $ref->recipientRef=$a->postcode;
    $skybill->service='0';

	// CARRIER-SPECIFIC
	switch($o->id_carrier)
	{
		case Configuration::get('CHRONORELAIS_CARRIER_ID'):
            if($isReturn) break; // returns are Chrono13
		    $skybill->productCode=Chronopost::$productCodes['CHRONORELAIS_CARRIER_ID'];

            $row=Db::getInstance()->getRow('SELECT id_pr FROM '._DB_PREFIX_.'chrono_cart_relais WHERE id_cart='.$o->id_cart);
        	$ref->recipientRef=$row['id_pr'];
            $ws=new PointRelaisServiceWSService();


            $p=new rechercheBtAvecPFParIdChronopostA2Pas();
            $p->id=$row['id_pr'];

            $bt=$ws->rechercheBtAvecPFParIdChronopostA2Pas($p)->return;
            
	        $recipient->recipientAdress1=$bt->adresse1;
	        $recipient->recipientAdress2=$bt->adresse2;
	        $recipient->recipientCity=$bt->localite;
	        $recipient->recipientCivility='M';
	        $recipient->recipientCountry='FR';
	        $recipient->recipientName=$bt->nomEnseigne;
	        $recipient->recipientZipCode=$bt->codePostal;



		break;

		case Configuration::get('CHRONOEXPRESS_CARRIER_ID'): 
            if($isReturn) break; // returns are Chrono13
	  	    $skybill->productCode=Chronopost::$productCodes['CHRONOEXPRESS_CARRIER_ID'];
		break;

        case Configuration::get('CHRONOPOST_CARRIER_ID'):
      	    $skybill->productCode=Chronopost::$productCodes['CHRONOPOST_CARRIER_ID'];
            if(Configuration::get('CHRONOPOST_BAL_ENABLED')==1 && !$isReturn)
                $skybill->productCode='58'; // CHRONO 13 + BAL
        break;

        case Configuration::get('CHRONO18_CARRIER_ID'):
            if($isReturn) break; // returns are Chrono13
      	    $skybill->productCode=Chronopost::$productCodes['CHRONO18_CARRIER_ID'];
            if(Configuration::get('CHRONOPOST_BAL_ENABLED')==1)
                $skybill->productCode='2M'; // CHRONO 18/ + BAL
        break;

		case Configuration::get('CHRONO10_CARRIER_ID'): 
            if($isReturn) break; // returns are Chrono13
	  	    $skybill->productCode=Chronopost::$productCodes['CHRONO10_CARRIER_ID'];
		break;

		case Configuration::get('CHRONOCLASSIC_CARRIER_ID'): 
            if($isReturn) break; // returns are Chrono13
	  	    $skybill->productCode=Chronopost::$productCodes['CHRONOCLASSIC_CARRIER_ID'];
		break;



	}

    
	$ref->shipperRef=sprintf("%06d", $orderid);

	
    if($o->id_carrier != Configuration::get('CHRONOCLASSIC_CARRIER_ID') && $o->id_carrier != Configuration::get('CHRONOEXPRESS_CARRIER_ID'))
    {
        // Called from hookAdminOrder
	    if(array_key_exists('shipSaturday', $_POST) or array_key_exists('shipSaturday', $_GET))
		    $skybill->service='6';
        // Called from export admin
        if(array_key_exists('orders', $_GET) && Chronopost::isSaturdayOptionApplicable())
            $skybill->service='6';
        
        // Called from orders pane
        if(array_key_exists('orderid', $_GET) && Chronopost::isSaturdayOptionApplicable())
            $skybill->service='6';

        // Could be shipping for saturday but is not
        if(Chronopost::gettingReadyForSaturday() && $skybill->service!='6') $skybill->service='1';

    }




    //echo Chronopost::gettingReadyForSaturday()." ".$skybill->service;

	$skybill->shipDate=date('Y-m-d\TH:i:s');
	$skybill->shipHour=date('H');
    // weight 0 when multishipping
	$skybill->weight=0;
    // Only 1 skybill, put real weight. 
    if($totalnb==1) $skybill->weight=$o->getTotalWeight()*Configuration::get('CHRONOPOST_GENERAL_WEIGHTCOEF');

	$skybill->weightUnit='KGM';


	$skybillParams=new skybillParamsValue();
	$skybillParams->mode=Configuration::get('CHRONOPOST_GENERAL_PRINTMODE');;


	$params->esdValue=$esd;
	$params->headerValue=$header;
	$params->shipperValue=$shipper;
	$params->customerValue=$customer;
	$params->recipientValue=$recipient;
	$params->refValue=$ref;
	$params->skybillValue=$skybill;






	$params->skybillParamsValue=$skybillParams;

	$service=new ShippingServiceWSService();

	$r=$service->shipping($params)->return;


/*
	var_dump($params);
	var_dump($service->shipping($params)->return);
*/



	if($r->errorCode!=0)
	{
        if($r->errorCode<=33) echo '<h1>Erreur</h1><p>Le numéro de compte ou le mot de passe saisi lors de la configuration du module est incorrect, veuillez les modifier dans la configuration du module Chronopost.</p>';
        else 
        {
            echo '<h1>Erreur</h1><p>Erreur à la génération : erreur système ou adresse de livraison incorrecte</p>';
            Chronopost::errorStatus($o->id);
        }

		return null;
	}



	if($isReturn) {
        $customer=new Customer($o->id_customer);        
        Mail::Send($o->id_lang, 'return', 'Lettre de transport Chronopost pour le retour de votre commande' , 
            array('{id_order}'=>$o->id, '{firstname}' => $customer->firstname,
			'{lastname}' => $customer->lastname,), $customer->email, 
            $customer->firstname.' '.$customer->lastname, NULL, NULL, 
            array('content'=>$r->skybill, 'mime'=>'application/pdf', 'name'=>$r->skybillNumber.'.pdf'), 
            NULL, __DIR__.'/mails/', true);
    }
    else {
        // Store LT for history
        Db::getInstance()->execute('INSERT INTO `'._DB_PREFIX_.'chrono_lt_history` VALUES (
                '.$o->id.', 
                "'.$r->skybillNumber.'", 
                "'.$skybill->productCode.'",
                "'.$recipient->recipientZipCode.'",
                "'.$recipient->recipientCountry.'",
                "'.(isset($skybill->insuredValue)?$skybill->insuredValue:0).'",
                "'.$recipient->recipientCity.'"
            )');

        Chronopost::trackingStatus($o->id, $r->skybillNumber);
    }

/*
    header('Content-type: application/pdf');
header('Content-Disposition: attachment; filename="downloaded.pdf"');

	echo $r->skybill; 
    die();*/
	return $r->skybill;
}

